#include "Eigen\Core"
#include "Eigen\SVD"
#include <vector>
#define M_PI 3.141592653589793

void TokenizeString(const std::string &line,std::vector<std::string> &tokens);
void DiscreteToContinousScaling(const double minX, const double maxX, const double currentValue, double *alpha1, double *alpha2);
void FindIndices(unsigned int *indexBelow, unsigned int *indexAbove, double value, std::vector<double> vectorOfValues,const unsigned int indexOfLastBelow, const unsigned int indexOfLastAbove);
void RotationMatrix(Eigen::Matrix3d* rotationMatrix, double value1, double value2, double value3);
void RotationMatrix(Eigen::Matrix3f* rotationMatrix, double value1, double value2, double value3);
void Smtrx(Eigen::Matrix3d *skewSymmetricMatrix,double value1, double value2, double value3);
void Smtrx(Eigen::Matrix3f *skewSymmetricMatrix,double value1, double value2, double value3);
Eigen::Matrix3f RotationMatrix(Eigen::Vector3f vector);
Eigen::Matrix3f TransformationMatrix(Eigen::Vector3f vector);
Eigen::Matrix3f Smtrx(Eigen::Vector3f vector);
Eigen::Matrix<double,6,6> Jmatrix(const double * const eta);
double Modulus(double a, double b);
int round(double number);
int sign(double number);
std::string intToString(int i);
double ShortestError(double eta, double etaRef);
double RAD2PIPI(double angleIn);


//const double* const Omega2Quaternion(double phi, double theta, double psi);