////////////////////////////////////////////////////////////////////////////////////////////////////
/// \class							ControlAlgorithm
////////////////////////////////////////////////////////////////////////////////////////////////////
//
/// \author			Mats Nvik Hval
///
///	Superclass of control algorithms
///
/// \par Revision history:
///					20.06.2011 MNH: Initial version.
///
////////////////////////////////////////////////////////////////////////////////////////////////////
#include "ControlAlgorithm.h"

////////////////////////////////////////////////////////////////////////////////////////////////////
//==================================================================================================
// FUNCTION NAME:		ControlAlgorithm Constructor
//==================================================================================================
///		This constructor performs all initial setup for a Control algorithm simobject.
///		Reading in parameters, setting up communication interface i.e. output ports,
///		input ports, and states, plus additional 'one time only' resource setup.
///	
/// \param [in]		simObjectName	The name of the simobject. Used primarily 
///									by superclass constructor
///
/// \param [in]		creator			Retrive parameters. Register states, ports
///									and shared resources
///
////////////////////////////////////////////////////////////////////////////////////////////////////
ControlAlgorithm::ControlAlgorithm(const string& simObjectName, ISimObjectCreator* const creator) : CSimObject(simObjectName)
{
}

void ControlAlgorithm::OdeFcn(const double T, const double* const X, double* const XDot, const bool bIsMajorTimeStep){

}