#include "FroudeKrylov.h"
#include "Eigen\Core"
#include <vector>
#include <fstream>


class FroudeKrylovWamit : public FroudeKrylovForce
{
public:
	void Read( std::string fname );
	
	std::complex<double> GetRAOValue(unsigned int DOF,  double ShipDirection, double ShipSpeed, double WaveFrequency );
	void GetRAOValues( unsigned int DOF, double ShipDirection, double ShipSpeed, Eigen::Matrix< std::complex<double>,Eigen::Dynamic,1 > &outRAO);

	void GetRAOValue2(unsigned int DOF,  double ShipDirection, double ShipSpeed, double WaveFrequency, double &Magnitude, double &Phase );
	void GetRAOValues2( unsigned int DOF, double ShipDirection, double ShipSpeed, Eigen::Matrix< double,Eigen::Dynamic,1 > &outRAOmag,Eigen::Matrix< double,Eigen::Dynamic,1 > &outRAOphase);


protected:

private:
	std::ifstream file;	

}