#include "Eigen\Core"
#include <vector>
#include <sfhGeneral.h>
#include "fhConstants.h"
#define M_PI 3.141592653589793

void TokenizeString(const std::string &line,std::vector<std::string> &tokens);
void DiscreteToContinousScaling(const double minX, const double maxX, const double currentValue, double *alpha1, double *alpha2);
void FindIndices(unsigned int *indexBelow, unsigned int *indexAbove, double value, std::vector<double> vectorOfValues,const unsigned int indexOfLastBelow, const unsigned int indexOfLastAbove);

void RotationMatrix(Eigen::Matrix3d* rotationMatrix, double value1, double value2, double value3);
Eigen::Matrix3d RotationMatrix(Eigen::Vector3d vector);

void Smtrx(Eigen::Matrix3d *skewSymmetricMatrix,double value1, double value2, double value3);
Eigen::Matrix3d Smtrx(Eigen::Vector3d vector);

Eigen::Matrix3d TransformationMatrix(Eigen::Vector3d vector);
Eigen::Matrix<double,6,6> Jmatrix(const double * const eta);
double Modulus(double a, double b);

double RAD2PIPI(double angleIn);
//const double* const Omega2Quaternion(double phi, double theta, double psi);