////////////////////////////////////////////////////////////////////////////////////////////////////
/// \class							PotentialForce
////////////////////////////////////////////////////////////////////////////////////////////////////
//
/// \author			Mats Nvik Hval
///
///	\par Revision history:
///					02.05.2012 MNH: Initial version.
///
////////////////////////////////////////////////////////////////////////////////////////////////////
#include "PotentialForce.h"


PotentialForce::PotentialForce(const std::string fileName, const std::string fileBaseLocation){

	potentialFileLocation = fileBaseLocation;
	potentialFileName = fileName;
}

void PotentialForce::setEnvironment(DeepSeaGravityWaves *environment_ptr){

	environment = environment_ptr;

	if( environment )
	{
		environment->GetWaveAmplitudes	( waveHeight );
		environment->GetWaveFrequencies	( waveFrequency );
		environment->GetWavePhaseAngles	( wavePhase );
		environment->GetWaveDirections	( waveDirection );
		environment->GetWaveNumbers		( waveNumber );

		while( waveHeight.size() > 1 && waveHeight.back() == 0 )
		{
			waveHeight.pop_back();
			waveFrequency.pop_back();
			wavePhase.pop_back();
			waveDirection.pop_back();
			waveNumber.pop_back();
		}
	}

	if( waveFrequency.size() == 0)
	{
		waveHeight.push_back(0);
		waveFrequency.push_back(0);
		wavePhase.push_back(0);
		waveDirection.push_back(0);
		waveNumber.push_back(0);
	}
	double pos[] = {0,0};
	seaDepth = environment->GetSeadepth(pos);
}