#include "ROV.h"
#include "CNetCage.h"

ROV::ROV(const string& simObjectName, ISimObjectCreator* const creator): WamitVessel(simObjectName, creator)
{
	double zero[] = {0,0,0};

	creator->AddInport	("UmbilicalForces",	 6, &inputUmbilicalForce);
	v_umbilicalForce = Eigen::Matrix<double,6,1>::Zero();

}

void ROV::OdeFcn(const double T , const double* const X,	double* const XDot,	const bool IsMajorTimeStep){
		//TODO fix current retrievement
	HydroStaticRestoringForces(T,X);
	WamitVessel::OdeFcn(T,X,XDot,IsMajorTimeStep);
	//pos[] = {X[indexEta],X[indexEta+1],X[indexEta+2]};
	//double currentSpeed[]= {0,0,0};
	//environment->GetCurrentVelocity(T,X,pos,currentSpeed);
	//currentVelocity << currentSpeed[0],currentSpeed[1],currentSpeed[2],0,0,0;

	//nu << X[indexNu],X[indexNu+1],X[indexNu+2],X[indexNu+3],X[indexNu+4],X[indexNu+5];
	//
	//Eigen::Matrix<double,6,6> J = Jmatrix(X+indexEta);
	//Eigen::Matrix<double,6,6> Jinv = J.inverse();

	//nuRelative = nu;// - Jinv*currentVelocity;

//	RigidBodyCoriolisForces(T,X);
//	AddedMassCoriolisForces(T,X);
//	FluidMemoryForces(T,X);
	
//	FroudeKrylovForces(T,X);
//	MeanDriftWaveForces(T,X);
//	VaryingCurrentDirectionForces(T,X);
//	getViscousForces(T,X);

//	v_FKForces = Eigen::Matrix<double,6,1>::Zero();
//	v_MeanDriftForces = Eigen::Matrix<double,6,1>::Zero();
	
	
	//v_SUMforces += v_umbilicalForce; 

	//v_SUMforces = v_sumWOwaveFrequencyForces /*+ v_FKForces*/ ;
	if (waveForces)
		nuDotMean = mInv * (v_SUMforces + v_FKForces - v_fluidMemoryForces + v_umbilicalForce) - (mInv * v_SUMforces + v_umbilicalForce);
	else
		nuDotMean = mInv * (v_SUMforces + v_umbilicalForce);
	
	//v_SUMforces += surfaceDamping;
	nuDot = mInv *v_SUMforces;
	etaDot = Jmatrix(X+indexEta) * nu;

	for (size_t i = 0 ; i<6 ; i++){
		XDot[indexMeanNu+i]= nuDotMean[i];
		XDot[indexNu + i] = nuDot[i];
		XDot[indexEta +i] = etaDot[i];
	}
	
}

void ROV::HydroStaticRestoringForces(const double T, const double* const X){

	//double pos[] = {X[indexEta],X[indexEta+1]};
	////double surfaceElevation =  environment->GetSurfaceElevation(T,X,pos);
	//double depth = X[indexEta+2];// - surfaceElevation;
	//if (depth < 0.5*vesselMainDimensions[2]){
	//	atSurface = true;
	B = VOLUME*RHO*GRAVITY;//B = (VOLUME - vesselMainDimensions[0]*vesselMainDimensions[1]*(0.5*vesselMainDimensions[2]-depth))*RHO*GRAVITY;
	//}
	//else
	//	B = VOLUME*RHO*GRAVITY;
	//	atSurface = false;
	
	PotentialVessel::HydroStaticRestoringForces(T,X);

}
void ROV::UmbilicalForces(const double T, const double* const X){
	const double* umbilicalForceArray = inputUmbilicalForce->GetPortValue(T,X);

	for (size_t i =0;6;i++){
		v_umbilicalForce(i) = umbilicalForceArray[i];
	}	
}
	