#ifndef ROV_h
#define ROV_h
#include "WamitVessel.h"
#include "HelpFunctions.h"

class ROV : public WamitVessel
{
public:
	EIGEN_MAKE_ALIGNED_OPERATOR_NEW
	ROV(const string& simObjectName, ISimObjectCreator* const creator);
	void OdeFcn(const double T , const double* const X,	double* const XDot,	const bool IsMajorTimeStep); 

protected:
	void HydroStaticRestoringForces(const double T, const double* const X);
	void UmbilicalForces(const double T, const double* const X);

	ISignalPort* inputUmbilicalForce;				/// Input port. Forces and moments from the umbilical force
	double umbilicalForceBody3DOF[3];
	bool atSurface;
	//double umbilicalForces[6];

	//double umbilicalForceArray[6];

	//Eigen::Vector3f umbilicalForceNED;
	//Eigen::Vector3f umbilicalForceBODY;
	//Eigen::Vector3f eta2;
	Eigen::Matrix<double,6,1> v_umbilicalForce;						/// Forces due to the umbilical
	//Eigen::Matrix<double,6,1> umbilicalForceBody6DOF;
	//Eigen::Matrix<double,6,1> mInverseTauUmbilical;

};
#endif