#include <map>
#include <complex>
#include <string>
#include "Eigen\Core"
#include <vector>
#include "HelpFunctions.h"
#include <Eigen/StdVector>

//#include "PotentialData.h"

class WamitData{//: public PotentialData{
	/*class TransferFunction
	{	
	public:
		void Read( std::string &fname ); // Reads transfer functions depending on direction 
		std::complex<double> GetRAOValue(int DOF, double direction,double frequnecy); // retreives a complex transfer funciton value
	private:
		Eigen::Matrix<double,1,Eigen::Dynamic> Frequencies;	// Freqeuncies of transfer function
		Eigen::Matrix<double,1,Eigen::Dynamic> Directions;	// Directions of Transfer function
		
		Eigen::Matrix<std::complex<double>,1,Eigen::Dynamic> *RAO; // RAO vector with complex value TF for each direction in Directions 
	};*/

public: 
	EIGEN_MAKE_ALIGNED_OPERATOR_NEW
	WamitData();
	void Read( std::string &fname ); // fills A,B and C matrix

private:

//	void TokenizeString(const std::string &line,vector< std::string > &tokens);

	
	Eigen::Matrix<double,6,6> Mrb;

	double LCG,VCG;
	double VOLUME;
	double WATERDEPTH;
	Eigen::Matrix<double,3,1> CG,CB;
	Eigen::Matrix<double,4,1> XBODY;
	Eigen::Matrix<double,6,6> Mrbeig;
	
	Eigen::Matrix<double,1,Eigen::Dynamic> Directions;
	Eigen::Matrix<double,1,Eigen::Dynamic> Frequencies;

	std::vector<std::vector<std::vector<Eigen::Matrix<double,6,6>, Eigen::aligned_allocator< Eigen::Matrix< double, 6, 6 > >>>> A;			// 6x6 added mass pr frequency
	std::vector<std::vector<std::vector<Eigen::Matrix<double,6,6>, Eigen::aligned_allocator< Eigen::Matrix< double, 6, 6 > >>>> B;			// 6x6 dampening pr frequency
	Eigen::Matrix<double,6,6> C;														// restoring matrix from WAMIT. Can be considered linear for floating vessels at zero or moderate speed. 

	std::map<std::string,double> HullParameters; // containes "String"->"double" parameters for the hull (Length/Bredth etc)
};