#include <fstream>
#include <complex>
#include <vector>
#include "Eigen\Core"

class WaveForce
{
public:
	virtual void Read( const std::string &fname );

	std::complex<double> GetRAOValue(int DOF, double WaveFrequency, double WaveDirection);

protected:

private:
		
	std::vector<double> wavePeriod;
	std::vector<double> waveHeading;

	std::ifstream file;	
	double GRAVITY,RHO,ULEN,WATERDEPTH;
	size_t indexOfLastWaveHeadingBelow, indexOfLastWaveHeadingAbove;	// Index in the waveHeading vector of the heading angle below and above the actual heading
	size_t indexOfLastWavePeriodBelow,indexOfLastWavePeriodAbove;		// Index in the wavePeriod vector of the Period below and above the actual period
	
	std::vector< std::vector< Eigen::Matrix<double,9,4> > > RAOdata;	// data from the RAO-output file. Sorted on heading, then frequency.	

};
